#include<iostream>
using namespace std;

#include "Eigen.hpp"
#include "dco.hpp"

int main() { // computes the inverse of A as dx/db
  const int n=3;
  using T=dco::gt1s<float>::type; // tangent type
  using VT=Eigen::vector_t<T>; // vector of tangent type variables
  using MT=Eigen::matrix_t<T>; // matrix of tangent type variables
  VT x(n), b=VT::Random(n); MT A=MT::Random(n,n);
  for (int i=0;i<n;i++) {
    dco::derivative(b(i))=1; // seed
    x=A.lu().solve(b); // propagate
    for (int j=0;j<n;j++) cout << dco::derivative(x(j)) << " "; // harvest
    cout << endl;
    dco::derivative(b(i))=0; // unseed
  }
  cout << A.inverse().transpose() << endl;
  return 0;
}
