#include<iostream>
using namespace std;

#include "Eigen.hpp"
#include "dco.hpp"

int main() { // computes the inverse of A a dx/db
  const int n=3;
  using M=dco::ga1s<float>; using T=M::type;
  using VT=Eigen::vector_t<T>; using MT=Eigen::matrix_t<T>;
  VT x(n), b=VT::Random(n); MT A=MT::Random(n,n);
  dco::smart_tape_ptr_t<M> tape; // enable recording of tape
  for (int i=0;i<n;i++) tape->register_variable(b(i)); // register active input
  x=A.lu().solve(b); // record tape
  for (int i=0;i<n;i++) tape->register_output_variable(x(i)); // register active output
  for (int i=0;i<n;i++) {
    dco::derivative(x(i))=1; // seed
    tape->interpret_adjoint(); // propagate adjoint
    for (int j=0;j<n;j++) cout << dco::derivative(b(j)) << " "; // harvest
    tape->zero_adjoints(); // prepare for re-seed
  }
  return 0;
}
