#include<iostream>
using namespace std;

#include "dco.hpp" // dco/c++ header

int main() {
  dco::ga1s<float>::type x,y; // adjoint type variables
  dco::value(x)=2; // set primal value of active input
  dco::smart_tape_ptr_t<dco::ga1s<float>> tape; // enable recording of tape
  tape->register_variable(x); // register active input with tape (should be read-only)
  y=sin(x); // evaluate primal and record tape
  tape->register_output_variable(y); // register active output (to makes it write-only)
  cout << dco::value(y) << endl; // get primal value of active input
  dco::derivative(y)=1; // seed adjoint of active output 
  tape->interpret_adjoint(); // propagate adjoint
  cout << dco::derivative(x) << endl; // harvest adjoint of active input 
  return 0;
}
