#include<iostream>
using namespace std;

#include "dco.hpp" // dco/c++ header

int main() {
  using M=dco::ga1s<dco::gt1s<float>::type>; // second-order adjoint mode
  M::type x,y; // second-order adjoint type variables
  dco::value(dco::value(x))=2; // set primal value of active input
  dco::derivative(dco::value(x))=1; // seed first-order tangent
  dco::smart_tape_ptr_t<M> tape; // enable recording of tape
  tape->register_variable(x); // register active input 
  y=sin(x); // evaluate primal and record tape
  tape->register_output_variable(y); // register active output 
  cout << dco::value(dco::value(y)) << " "; // get primal value of active output
  cout << dco::derivative(dco::value(y)) << " "; // harvest first-order tangent
  dco::derivative(y)=1; // seed first-order adjoint of active output
  tape->interpret_adjoint(); // propagate adjoint
  cout << dco::value(dco::derivative(x)) << " "; // harvest first-order adjoint
  cout << dco::derivative(dco::derivative(x)) << endl; // harvest second-order adjoint
  return 0;
}
